#ifndef _HATP_OPRS_LEXER_H
#define _HATP_OPRS_LEXER_H

#include <string>

//TODO replace by a dependency to default-lexer.hh instead
#include "hatpLexer.hh"

using namespace std;

// ---------- Default OpenPRS parsing ----------
static const string OLPAREN		= "[(]";
static const string ORPAREN		= "[)]";
static const string OLLIST		= "[(][[.period.]]" + SPACE;
static const string ORLIST		= SPACE + "?[[.period.]][)]";
static const string OCLIST		= "((([[:word:]]+[[:space:]]?))*)";
static const string OLIST		= OLLIST + OCLIST + ORLIST;

// ---------- OPRS plan request parsing ----------
static const string O_HATPREQ	= "HATP-REQ";
static const string O_REQTYPE	= "REQ-TYPE";
static const string O_REQID		= "REQ-ID";
static const string O_TASKNAME	= "TASK-NAME";
static const string O_PARAMS	= "PARAMETERS";

static const string OREQTYPE 	= OLPAREN + O_REQTYPE + SPACE + WORD + ORPAREN;
static const string OREQID	= OLPAREN + O_REQID + SPACE + WORD + ORPAREN;
static const string OTASKNAME	= OLPAREN + O_TASKNAME + SPACE + WORD + ORPAREN;
static const string OPARAMS	= OLPAREN + O_PARAMS + SPACE + OLIST + ORPAREN;

static const string HATPREQ 	= OLPAREN + O_HATPREQ + SPACE + OREQTYPE + SPACE + OREQID + SPACE + OTASKNAME + SPACE + OPARAMS + ORPAREN;

// ---------- OPRS ontology reply ----------

static const string O_RESULT	= "ONTO_RESULT" + SPACE;
static const string O_REQ_ID	= NUMBER + SPACE;
static const string O_STATUS	= WORD + SPACE;
static const string O_PRELIST	= ".*";

static const string ONTOREPLY	= OLPAREN + O_RESULT + O_REQ_ID + O_STATUS + OLLIST + "(.*)" + ORLIST + ORPAREN; //Used to detect the status

static const boost::regex findReply(ONTOREPLY);
static const boost::regex findValue("[[:word:][.period.]_]+");

// ---------- OPRS ontology reply for all ----------

static const string O_RESULTALL = "DbCopyRes" + SPACE;

static const string ONTOREPALL	= OLPAREN + O_RESULTALL + O_REQ_ID + O_STATUS + OLLIST + "(.*)" + ORLIST + ORPAREN;
static const string OPROPERTIES = OLLIST + ".*?" + ORLIST;

static const boost::regex copyAllReply(ONTOREPALL);
static const boost::regex propertiesReply(OPROPERTIES);

#endif
