#ifndef MSGCLIENT_HH
#define MSGCLIENT_HH

#include<iostream>
#include<sstream>

#include <iclient.hh>
#include <msgConstants.hh>

class msgClient {

	private:
		iclient client;
		std::string name;
		std::string s_name;
		unsigned int s_port;
		
	public:
		msgClient();
		~msgClient();
		bool connect(const std::string& name, const std::string& server, unsigned int port);
		void disconnect();
		bool isConnected();
		bool isMessageWaiting();
		bool sendMessage(const std::string& dest, const std::string& content);
		bool sendBroadcastMessage(const std::string& content);
		std::pair<std::string, std::string> getMessage();
		std::pair<std::string, std::string> getBlockingMessage();
		
};

#endif
